extends ../_docs-template

block vars
  - var activeLink = 'vue';
  - var title = 'Treeview Vue Component | Framework7 Vue Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu-vue
  .docs-content
    .motion-docs-page-title
      h1 Treeview Vue Component
      script(src="/js/motion/treeview.js")
      f7-motion-treeview(motion)

    p Treeview Vue component represents Framework7's <a href="/docs/treeview.html">Treeview</a> component.

    h2 Treeview Components
    p There are following components included:
    ul
      li `f7-treeview` - main treeview container
      li `f7-treeview-item` - treeview item

    h2 Treeview Properties
    table.params-table
      thead
        tr
          th Prop
          th Type
          th Default
          th Description
      tbody
        tr
          th(colspan="4") &lt;f7-treeview-item&gt; properties
        tr
          td toggle
          td boolean
          td
          td Enables treeview item toggle button. By default enabled if there are children item
        tr
          td item-toggle
          td boolean
          td false
          td Enables whole treeview item as toggle
        tr
          td selectable
          td boolean
          td false
          td Makes item selectable
        tr
          td selected
          td boolean
          td
          td Makes item selected
        tr
          td opened
          td boolean
          td false
          td Defines whether the item opened by default or not
        tr
          td label
          td string
          td
          td Item label text
        tr
          td load-children
          td boolean
          td false
          td Enable when you need to load children items on open.
        tr
          td link
          td string<br>boolean
          td
          td Enables link and link URL if specified as string. Same as `href` attribute

        tr
          th(colspan="4") &lt;f7-treeview-item&gt; icon related properties
        +vueLinkIconProps
        tr
          th(colspan="4") &lt;f7-treeview-item&gt; navigation/router related properties
        +vueLinkRouterProps
        tr
          th(colspan="4") &lt;f7-treeview-item&gt; action related properties
        +vueLinkActionsProps

    h2 Treeview Events
    table.events-table
      thead
        tr
          th Event
          th Description
      tbody
        tr
          th(colspan="2") &lt;f7-treeview-item&gt; events
        tr
          td click
          td Event will be triggers when user clicks on treeview item
        tr
          td treeview:open
          td Event will be triggered on item open
        tr
          td treeview:close
          td Event will be triggered on item close
        tr
          td treeview:loadchildren
          td Event will be triggered on first open of Treeview item with `loadChildren` prop. In `event.detail` it contains function to hide loading preloader.

    h2 Treeview Item Slots
    p Treeview Vue component (`<f7-treeview-item>`) has additional slots for custom elements:
    ul
      li `root-start` - element will be inserted in the beginning of treeview item element
      li `root` / `root-end` - element will be inserted in the end of treeview item element
      li `content-start` - element will be inserted in the beginning of `<div class="treeview-item-content">` element
      li `content` / `content-end` - element will be inserted in the end of `<div class="treeview-item-content">` element
      li `children-start` - element will be inserted in the beginning of the `<div class="treeview-item-children">` element
      li `default` - element will be inserted in the end of the `<div class="treeview-item-children">` element
      li `media` - element will be inserted before `<div class="treeview-item-label">` element
      li `label-start` - element will be inserted in the beginning `<div class="treeview-item-label">` element
      li `label` - element will be inserted in the end of `<div class="treeview-item-label">` element
    :code(lang="html")
      <f7-treeview-item label="Item 1">
        <img src="path-to-my-image.jpg" slot="media">
        <div slot="root-start">Root Start</div>
        <div slot="root">Root End</div>
        <div slot="content-start">Content Start</div>
        <div slot="content">Content End</div>
        <span slot="label-start">Before Label</span>
        <f7-treeview-item label="Sub Item 1" />
        ...
      </f7-treeview-item>

      <!-- Renders to: -->
      <div class="treeview-item">
        <div class="treeview-item-root">
          <div>Root Start</div>
          <div class="treeview-toggle"></div>
          <div class="treeview-item-content">
            <div>Content Start</div>
            <img src="path-to-my-image.jpg">
            <div class="treeview-item-label">
              <span>Before Label</span>
              Item 1
            </div>
            <div>Content End</div>
          </div>
        </div>
        <div class="treeview-item-children">
          <div class="treeview-item">
            <div class="treeview-item-root">
              <div class="treeview-item-content">
                <div class="treeview-item-label">Sub Item 1</div>
              </div>
            </div>
          </div>
          ...
        </div>
        <div>Root End</div>
      </div>


    h2 Examples
    +examplePreview('vue', 'treeview.vue', 'treeview')
